function i = distanceEstimation(leftImage, rightImage, focalLengthLeft, diameterLeft, focalLengthRight, diameterRight, distance) 

left = imread(leftImage);
right = imread(rightImage);

figure , [object,object_left] = imcrop(left);
%imshow(object)
%figure, imshow(right)   

% interactively
object = object; % choose one petal of object
rsize = size(object);
rect_object = [0 0 rsize(2) rsize(1)];
%[sub_right,rect_right] = imcrop(right); % choose whole object
fsize = size(right);
rect_right = [0 0 fsize(2) fsize(1)];
sub_right=imcrop(right,rect_right);

% display sub images
%figure, imshow(object)
%figure, imshow(sub_right)   


c = normxcorr2(object(:,:,1),sub_right(:,:,1));
%figure, surf(c), shading flat

% offset found by correlation
[max_c, imax] = max(abs(c(:)));
[ypeak, xpeak] = ind2sub(size(c),imax(1));
corr_offset = [(xpeak-size(object,2)) 
               (ypeak-size(object,1))];

% relative offset of position of subimages
rect_offset = [(rect_right(1)-rect_object(1)) 
               (rect_right(2)-rect_object(2))];

% total offset
offset = corr_offset + rect_offset;
absof = offset;
xoffset = absof(1);
yoffset = absof(2);



xbegin = xoffset+1;

xend   = xoffset+ size(object,2);
ybegin = yoffset+1;
yend   = yoffset+size(object,1);

% extract region from right and compare to object
extracted_object = right(ybegin:yend,xbegin:xend,:);
% if isequal(object,extracted_object) 
%    disp('object.tif was extracted from right.tif');
% end


recovered_object = uint8(zeros(size(right)));
recovered_object(ybegin:yend,xbegin:xend,:) = object;
%figure, imshow(recovered_object)


[m,n,p] = size(right);
mask = ones(m,n); 
i = find(recovered_object(:,:,1)==0);
mask(i) = .2; % try experimenting with different levels of 
              % transparency

% overlay images with transparency
figure, imshow(right(:,:,1)); % show only red plane of right
hold on
h = imshow(recovered_object); % overlay recovered_object
set(h,'AlphaData',mask);

imageSize = fsize(2)
%x value of object's center in left and right images
PLeft = (object_left(1)+object_left(1)+object_left(3))/2
PRight = (xbegin + xend)/2

%calculate the distance and return value
i = CalculateDistance(focalLengthLeft, focalLengthRight, diameterLeft, diameterRight, distance, PRight, PLeft, imageSize);

function object_distance = CalculateDistance(focalLengthLeft, focalLengthRight, diameterLeft, diameterRight, distance, PRight, PLeft, imageSize)

teta1 = atan(diameterLeft/(focalLengthLeft*2)) %left camera half angle of view
teta2 = atan(diameterRight/(focalLengthRight*2)) %right camera half angle of view

%object is between left and right lenses
if ((PLeft  > (imageSize/2))&&(PRight < (imageSize/2)))
    disp('CASE 1!!!');
    alpha1 = atan(((PLeft - (imageSize/2))/(imageSize/2))*tan(teta1));
    alpha2 = atan((((imageSize/2) - PRight)/(imageSize/2))*tan(teta2));
    mone = tan((pi/2) - alpha1)*tan((pi/2) - alpha2)*distance;
    mehane = tan((pi/2) - alpha1) + tan((pi/2) - alpha2);
    object_distance = mone /mehane
end   
if ((PLeft  > (imageSize/2))&&(PRight > (imageSize/2))||(PLeft  < (imageSize/2))&&(PRight < (imageSize/2)))
         alpha1 = atan((((imageSize/2) - PLeft)/(imageSize/2))*tan(teta1));
         alpha2 = atan(((PRight - (imageSize/2))/(imageSize/2))*tan(teta2));         
         if ((PLeft  > (imageSize/2))&&(PRight > (imageSize/2)))
             %object is to the left of left and right lenses
             disp('CASE 2!!!');             
             object_distance = (sin((pi/2) - alpha1)*(sin((pi/2) - alpha2))*distance)/(sin(-alpha1 + alpha2))
         else  
              %object is to the right of left and right lenses
             disp('CASE 3!!!');
             object_distance = (sin((pi/2) - alpha1)*(sin((pi/2) - alpha2))*distance)/(sin(-alpha2 + alpha1)) 
         end
end
if  (PLeft  == (imageSize/2))
    %object is infront of left lens
    disp('CASE 4!!!\n');
    alpha2 = atan((((imageSize/2) - PRight)/(imageSize/2))*tan(teta2));
    object_distance = tan((pi/2) - alpha2)*distance
end
if (PRight == (imageSize/2)) 
    %object is infront of right lens
    disp('CASE 5!!!\n');
    alpha1 = atan(((PLeft - (imageSize/2))/(imageSize/2))*tan(teta1));
    object_distance = tan((pi/2) - alpha1)*distance 
    %else disp('not supporting this case!!!\n');
end